/**
 *	@file	ParseInternetShortcutFile.cpp
 *	@brief	C^[lbgV[gJbg(.url)url擾. (g)
 *	@note
 *	+++ MtlWeb.cpp ɂ MdlParseInternetShortcutFile A֌W̊g.
 *		o[AhXo[ĂяoĂāAł MTL ̔eOA
 *		Mtl::MDITabCtrl Ă΂̂ŁAƂ肠 MTL ̃t.
 *		(MDITabCtrľĂѕPNbV悤ɂׂ...)
 */

#include "stdafx.h"
#include "DonutPFunc.h"
#include "DonutViewOption.h"
#include "FavoritesMenu.h"
#include "MtlDragDrop.h"
#include "ExplorerMenu.h"
#include "HlinkDataObject.h"
#include "MenuDropTargetWindow.h"
#include "FlatComboBox.h"
#include "DonutFavoritesMenu.h"
#include "ExStyle.h"
#include "SearchBar.h"
#include "MtlBrowser.h"
#include "AddressBar.h"
#include "Donut.h"		// CString Donut_GetActiveSelectedText() ̂
#include "ParseInternetShortcutFile.h"


#if defined USE_ATLDBGMEM
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



namespace MTL {


///+++ AhXo[̕Ԃ.
///     CSearchBarɗp. { CDonutAddressBar::̓֐Ăׂ΂A
/// 	  DonutAddressBar.hSearchBar.hincludeƌオǂ̂...
CString GetAddressBarText()
{
	return	CDonutAddressBar::GetAddressBarText();
}



///+++ strFilePath C^[lbgV[gJbg΁AۂurlɂĕԂ.
///    ̂ƂAgvpeB([unDonut])Ōw肪ݒ肳Ă炻𔽉f.
/// @return 0:C^[lbgV[gJbgȂ	1:Lurl. 2:w肪fꂽurlɂȂ.
int ParseInternetShortcutFile_SearchMode(CString &strFilePath, const CString& strSearch)
{
	CString 	strExt = strFilePath.Right(4);
	if (strExt.CompareNoCase( _T(".url") ) != 0)
		return 0;

	CIniFileI	pr0(strFilePath, _T("InternetShortcut"));
	CString 	strUrl = pr0.GetString(_T("URL"), NULL, INTERNET_MAX_PATH_LENGTH );
	pr0.Close();
	if (strUrl.IsEmpty())
		return 0;

  #if 0 //+++ gvpeBonĂ邩`FbN.
	CIniFileI	pr(strFilePath, DONUT_SECTION);
	if (pr.GetValue(EXPROP_KEY_ENABLED, 0) == 0) {
		strFilePath = strUrl;
		return 1;
	}
  #endif

	//+++ ɂ΂...AƂɂƗD...
	CDonutSearchBar *pSearch = dynamic_cast<CDonutSearchBar*>( CDonutSearchBar::GetInstance() );
  #if 1 //ndef NDEBUG
	if (pSearch) {
		CDonutSearchBar *pSearch0 = pSearch;
		pSearch = (CDonutSearchBar *) ::SendMessage(pSearch->GetTopLevelParent(), WM_GET_SEARCHBAR, 0, 0);
		ATLASSERT( pSearch == pSearch0 );
	}
  #endif
	if (pSearch) {
		bool		bUrlSearch = false;

		CString 	strIniFile	= strFilePath;
		CString 	strWord 	= strSearch;		// .

		CIniFileI	pr(strIniFile, DONUT_SECTION/*_T("unDonut")*/);
		bool		bAdrBar = pr.GetValue(_T("ExPropOpt"), 0) & 1;
		pr.Close();

	   #if 1	//Ȃ̂ŁAՂŁAdg݂𒼂
		// I͈͂΁AD悷.
		CString 		strSel = Donut_GetActiveSelectedText();
		if (strSel.IsEmpty() == 0) {
			strWord = strSel;
			if (bAdrBar)	// AhXo[Ăw肪Ƃ.
				bUrlSearch = true;
		}
	   #endif
		if (strWord.IsEmpty()) {
			if (bAdrBar) {	// AhXo[Ăw肪Ƃ.
				strWord    = CDonutAddressBar::GetAddressBarText();
				bUrlSearch = true;
			}
			if (strWord.IsEmpty()) {	// ܂񂪐ݒ肳ĂȂꍇ́Ao[̃eLXg擾.
				strWord    = pSearch->RemoveShortcutWord( MtlGetWindowText( pSearch->GetEditCtrl() ) );
				bUrlSearch = false;
			}
		  #if 0
			if (strWord.IsEmpty()) {	// ܂񂪋󂾂΁AeLXgI΂̗p.
				strWord    = Donut_GetActiveSelectedText();
			}
		  #endif
		}
		strFilePath   = strUrl;
		if (strWord.IsEmpty() == 0) {	// 񂪐ݒ肳ĂÂ悤Url쐬.
			CIniFileI	pr(strIniFile, DONUT_SECTION/*_T("unDonut")*/);
			bool rc = pSearch->GetOpenURLstr(strFilePath, strWord, pr, CString()/*strUrl*/);
			pr.Close();
			if (rc && bUrlSearch == 0) {	// url̎ȊO͗ɓ.
				pSearch->_AddToSearchBoxUnique(strWord);
			}
			return 2;
		}
	} else {
		strFilePath = strUrl;
	}
	return 1;
}



///+++ strFilePath C^[lbgV[gJbg΁AۂurlɂĕԂ.
///    ̂ƂAgvpeBŌw(unDonutSearch)ݒ肳Ă炻𔽉f.
bool ParseInternetShortcutFile(CString &strFilePath)
{
	return ParseInternetShortcutFile_SearchMode(strFilePath, CString()) != 0;
}


}	// MTL
